ArrayList<PVector> p;
ArrayList<Float> phases;
float r;
PVector pivot;
float thetaDir;
float pivotSpeed;
float count;

void setup() {
  size(600, 600);
  p = new ArrayList<PVector>();
  phases = new ArrayList<Float>();
  phases.add(0f);
  phases.add(1.57f);
  phases.add(3.14f);
  phases.add(4.71f);
  r = 4f*min(height/2, width/2)/5f;
  for (int i = 0; i < phases.size(); ++i) {
    PVector pi = new PVector();
    pi.x = r*cos(phases.get(i));
    pi.y = r*sin(phases.get(i));
    p.add(pi);
  }
  pivot = new PVector(0, 0);
  pivotSpeed = 1f;
  thetaDir = random(-(float)Math.PI,(float)Math.PI);
  count = 0;
  colorMode(HSB, 360, 100,  100, 255);
  background(255, 0, 255);
  strokeWeight(4);
}

void draw() {
  update();
  translate(width/2, height/2);
  for (int i = 0; i < phases.size(); ++i) {
    stroke((count/10) % 360, 100, 100, 20);
    line(pivot.x, pivot.y, p.get(i).x, p.get(i).y);
  }
}

void update() {
  ++count;
  for (int i = 0; i < phases.size(); ++i) {
    phases.set(i, phases.get(i) + 0.01f*(noise((count)*0.003f+i)-0.5f));
    PVector pi = p.get(i);
    pi.x = r*cos(phases.get(i));
    pi.y = r*sin(phases.get(i));
  }
  pivot.add(new PVector(pivotSpeed*cos(thetaDir),pivotSpeed*sin(thetaDir)));
  if (pivot.magSq()>r*r){
    thetaDir = atan2(pivot.y, pivot.x) + (float)Math.PI+random(-0.7f, 0.7f);
  }
}

